<?php
require_once '../../data/constant.php';

$err_msg = "";
$conn = "";
$data_object = null;
if (NO_SINGLE_SIGNON == 0) {
	require('../../../../mainfile.php');
	require_once '../../data/xdb_access.php';
} else if (NO_SINGLE_SIGNON == 1) {
	require_once '../../data/db_access.php';
	ini_set("session.save_handler","files");
	session_start();
	$data_object = new CDbAccess();
	if ($data_object->openDB() == false) {
		$err_msg .= $data_object->err_msg;
	} else {
		$conn = $data_object->conn;
	}
}
require_once '../../data/table_access.php';
require_once '../../data/data_for_lec.php';
require_once '../../data/data_for_group.php';
require_once '../../util/for_lecture.php';
require_once '../../util/for_analyze.php';

if (!isset($_SESSION[SESSION_ADMIN])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}

$ses_list = $_SESSION[SESSION_ADMIN];
$admin_status =$ses_list['status'];
$admin_id=$ses_list['teacher_id'];

$lecture_id="";
$lecture_name = "";
$groupid = "";
$pres_type=0;
$pres_note_percent = 0;
$pres_right_percent = 0;
$pres_submit_percent = 0;
$pres_quiz_percent = 0;
$show_mem_list = "";
$act_type="";
$upid = "";
$is_able = "";
$csv_txt = "";

if (!isset($_REQUEST["lecture_id"]) || !is_numeric($_REQUEST["lecture_id"])) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/login.php");
	exit;
}

$lecture_id = $_REQUEST["lecture_id"];
$lecture_object = new CLectureTableAccess();
$lec_data = $lecture_object->getOneLecInfo($conn,$lecture_id);
if ($lec_data <> false) {
	$lecture_name = htmlspecialchars($lec_data["lecture_nam"],ENT_QUOTES);
	$pres_type=$lec_data["pres_type"];
	$pres_note_percent = $lec_data["pres_note_percent"];
	$pres_right_percent = $lec_data["pres_right_percent"];
	$pres_submit_percent = $lec_data["pres_submit_percent"];
	$pres_quiz_percent = $lec_data["pres_quiz_percent"];
	$groupid = $lec_data["groupid"];
}

if ($admin_status <> 1 && $lec_data["teacher_id"] <> $admin_id) {
	header("Content-Type: text/html; charset=EUC-JP");
	header(URL_SET."teacher/index.php");
	exit;
}

if (!is_readable(DOWN_LOAD) || !is_writable(DOWN_LOAD)) {
	$is_able = "DISABLED";
	$err_msg .= _EXAM_TEA_ANALYZE_CSV_AUTH_ERR1.DOWN_LOAD._EXAM_TEA_ANALYZE_CSV_AUTH_ERR2;
}

if (isset($_POST["act_type"])) {
	//⤷ϥɥ
	$act_type = $_POST["act_type"];
}

if ($act_type == "status_change") {
	//ʾѹ
	$upid = $_POST["cuid"];
	$upvalue = $_POST[$upid];

	$pres_object = new CLecPresTableAccess();
	$pres_object->changeLecPresExe($conn,$upid,$lecture_id,$upvalue);
}

//饹ּԤΥ֥
$cl_mem_object = new CStudentInClassAccess();
$cl_mem_data = $cl_mem_object->getStudentsInClass($conn, $groupid);
if ($cl_mem_data == false) {
	$err_msg = "Failed to get students data";
} else {
	$analyze_object = new CClassMemberAnalysis();
	$analyze_object->setAnalyzeArr($conn,$lecture_id);
	$mem_ana_data = $analyze_object->getAnalyzeArr();

	$event_cnt = $analyze_object->getEventCnt();
	//var_dump($mem_ana_data);
	foreach ($cl_mem_data as $child) {
		$show_mem_list .= "<tr>";

		$show_mem_list .="<td>";
		$show_mem_list .= "<a href='../member_reg/detail.php?class_id=".$groupid;
		$show_mem_list .="&uid=".$child["student_id"];
		$show_mem_list .="&lecture_id=".$lecture_id;
		$show_mem_list .= "&lecture_name=".urlencode($lec_data["lecture_nam"]);
		$show_mem_list .="&st_name=".urlencode($child['student_nam'])."'>";
		$show_mem_list .= htmlspecialchars(mb_convert_encoding($child['student_nam'],'UTF-8', XOOPS_SRT_ENCODE),ENT_QUOTES);
		$show_mem_list .= "</a></td>";

		$csv_txt .= $child["student_id"].",";
		$csv_txt .= "'".mb_convert_encoding($child['student_nam'],'UTF-8', XOOPS_SRT_ENCODE)."',";

		$show_mem_list .= "<td>";
		if ($pres_type == 0) {
			//ʤϼʤ
			$show_mem_list .= $PRES_TYPE_ARR[0];
		} else if ($pres_type==1) {
			//QRɤˤ
			$show_mem_list .= "<SELECT NAME='".$child["student_id"]."' onChange='updatePresStatus (".$child["student_id"].")'>";
			$show_mem_list .= "<OPTION VALUE='0'>".$PRES_STATUS_ARR[0];
			$show_mem_list .= "</OPTION>";
			$show_mem_list .= "<OPTION VALUE='1' ";
			if ($mem_ana_data[$child["student_id"]]["pres_status"] == 1) {
				$show_mem_list .= "SELECTED";
				$csv_txt .= "'".$PRES_STATUS_ARR[2]."',";
			} else {
				$csv_txt .= "'".$PRES_STATUS_ARR[0]."',";
			}
			$show_mem_list .= ">".$PRES_STATUS_ARR[2]."</OPTION>";
			$show_mem_list .= "</SELECT>";

		} else {
			$show_mem_list .= "<SELECT NAME='".$child["student_id"]."' onChange='updatePresStatus (".$child["student_id"].")'>";
			for ($i=0; $i<=3; $i++) {
				$show_mem_list .= "<OPTION VALUE='".$i."' ";
//				if ($mem_ana_data[$child["student_id"]]["pres_status"] == $i) {
				if (isset($mem_ana_data[$child["student_id"]]["pres_status"]) && $mem_ana_data[$child["student_id"]]["pres_status"] == $i) {
					$show_mem_list .= "SELECTED";
					$csv_txt .= "'".$PRES_STATUS_ARR[$i]."',";
				}
				$show_mem_list .= ">".$PRES_STATUS_ARR[$i]."</OPTION>";
			}
			$show_mem_list .= "</SELECT>";
		}
		$show_mem_list .= "</td>";
		//$show_mem_list .= "<td>".$mem_ana_data[$child["student_id"]]["pres_status"]."</td>";

		if (!isset ($mem_ana_data[$child["student_id"]]["note_score"])) {
			$show_mem_list .="<td>-</td>";
			$csv_txt .= ",";
		} else {
			$show_mem_list .= "<td>".$mem_ana_data[$child["student_id"]]["note_score"]."(";
			$show_mem_list .= round($mem_ana_data[$child["student_id"]]["note_per"],2)."%)";
			if ($mem_ana_data[$child["student_id"]]["note_per"] == 100) {
				$show_mem_list .= " <b>GOOD</b>";
			} else if ($mem_ana_data[$child["student_id"]]["note_per"] < $pres_note_percent) {
				$show_mem_list .= " <font color='red'>NOTICE</font>";
			}
			$csv_txt .= $mem_ana_data[$child["student_id"]]["note_score"].",";

			$show_mem_list .= "</td>";
		}
		if (!isset ($mem_ana_data[$child["student_id"]]["sub_num"])) {
			$show_mem_list .="<td>-</td>";
			$csv_txt .=",";
		} else {
			$show_mem_list .= "<td>".$mem_ana_data[$child["student_id"]]["sub_num"]."(";
			$show_mem_list .= round(($mem_ana_data[$child["student_id"]]["sub_num"] / $event_cnt * 100),2)."%)";

			if ($mem_ana_data[$child["student_id"]]["sub_num"] == $event_cnt) {
				$show_mem_list .= " <b>GOOD</b>";
			} else if ($mem_ana_data[$child["student_id"]]["sub_num"] / $event_cnt *100 < $pres_submit_percent ) {
				$show_mem_list .= " <font color='red'>NOTICE</font>";
			}

			$csv_txt .= $mem_ana_data[$child["student_id"]]["sub_num"].",";

			$show_mem_list .= "</td>";
		}
		if (!isset($mem_ana_data[$child["student_id"]]["prac"])) {
			$show_mem_list .="<td>-</td>";
			$csv_txt .=",";
		} else {
			$show_mem_list .= "<td>".$mem_ana_data[$child["student_id"]]["prac"]."(";
			$show_mem_list .= round($mem_ana_data[$child["student_id"]]["prac_per"],2)."%)";

			if ($mem_ana_data[$child["student_id"]]["prac_per"] == 100) {
				$show_mem_list .= " <b>GOOD</b>";
			} else if ($mem_ana_data[$child["student_id"]]["prac_per"] < $pres_right_percent) {
				$show_mem_list .= " <font color='red'>NOTICE</font>";
			}

			$csv_txt .= $mem_ana_data[$child["student_id"]]["prac"].",";

			$show_mem_list .= "</td>";
		}
		if (!isset($mem_ana_data[$child["student_id"]]["quiz_score"])) {
			$show_mem_list .="<td>-</td>";
			$csv_txt .= ",\n";
		} else {
			$show_mem_list .= "<td>".$mem_ana_data[$child["student_id"]]["quiz_score"]."(";
			$show_mem_list .= round($mem_ana_data[$child["student_id"]]["quiz_per"],2)."%)";

			if ($mem_ana_data[$child["student_id"]]["quiz_per"] == 100) {
				$show_mem_list .= " <b>GOOD</b>";
			} else if ($mem_ana_data[$child["student_id"]]["quiz_per"] < $pres_quiz_percent) {
				$show_mem_list .= " <font color='red'>NOTICE</font>";
			}

			$csv_txt .= $mem_ana_data[$child["student_id"]]["quiz_score"]."\n";
			$show_mem_list .= "</td>";
		}
		$show_mem_list .="</tr>";
	}
}

if ($act_type == "csv_down" && $is_able=="") {
	//CSVΥ
	if ($down_file = fopen(DOWN_LOAD, "w")) {
		flock($down_file,2);
		fwrite ($down_file, mb_convert_encoding($csv_txt,CSV_ENCODE,"UTF-8"));
		flock($down_file,3);
		fclose($down_file);
		$d_file=DOWN_LOAD;
    	header ("Content-Type:application/octet-stream");
    	header ("Content-Disposition: attachment; filename=\"".DOWN_FILE."\"");
    	readfile ($d_file);
		if ($down_file = fopen(DOWN_LOAD, "w")){
			flock($down_file,2);
			//С夫csv鸫ʤ褦
				//Ŭڤ˥ѥѹСפ2007ǯ64
			fwrite ($down_file, "");
			flock($down_file,3);
			fclose($down_file);
		}
    	exit;
	} else {
		$err_msg .= _EXAM_COMMON_FILE_OPEN_ERR;
	}
}

if ($pres_note_percent == 0 || $pres_note_percent == "") {
	$pres_note_percent = _COMMON_NOTSET_TXT;
} else {
	$pres_note_percent = $pres_note_percent."%";
}
if ($pres_right_percent == 0 || $pres_right_percent == "") {
	$pres_right_percent = _COMMON_NOTSET_TXT;
} else {
	$pres_right_percent = $pres_right_percent."%";
}
if ($pres_submit_percent == 0 || $pres_submit_percent == "") {
	$pres_submit_percent = _COMMON_NOTSET_TXT;
} else {
	$pres_submit_percent = $pres_submit_percent."%";
}
if ($pres_quiz_percent == 0 || $pres_quiz_percent == "") {
	$pres_quiz_percent = _COMMON_NOTSET_TXT;
} else {
	$pres_quiz_percent = $pres_quiz_percent."%";
}
if ($conn <> "" && is_object($data_object)) $data_object->closeDB();

$show_data = file_get_contents(TEMPLATE_DIR.'ad_lec_reg/member_list.tpl');
$show_data = str_replace(':ERR_MSG:', $err_msg, $show_data);
$show_data = str_replace(':LEC_NAM_REP:', $lecture_name, $show_data);
$show_data = str_replace(':PRES_TYPE_REP:', $PRES_TYPE_ARR[$pres_type], $show_data);

$show_data = str_replace(':LEC_ID_REP:', $lecture_id, $show_data);

$show_data = str_replace(':NOTE_PERCENT_REP:', $pres_note_percent, $show_data);

$show_data = str_replace(':EVENT_SUBMIT_PERCENT_REP:', $pres_submit_percent, $show_data);
$show_data = str_replace(':RIGHT_PERCENT_REP:', $pres_right_percent, $show_data);
$show_data = str_replace(':QUIZ_PERCENT_REP:', $pres_quiz_percent, $show_data);
$show_data = str_replace(':ANALYZE_LIST_REP:', $show_mem_list, $show_data);

$show_data = str_replace(':IS_ABLE_REP:', $is_able, $show_data);

echo $show_data;

?>